'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _View2 = require('./View');

var _View3 = _interopRequireDefault(_View2);

var _ObjectView = require('./ObjectView');

var _ObjectView2 = _interopRequireDefault(_ObjectView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * View for Array model
 */
var ArrayView = function (_View) {
    _inherits(ArrayView, _View);

    /**
     * @param {Element} element
     */
    function ArrayView(element) {
        var _this;

        _classCallCheck(this, ArrayView);

        if (!(_this = _possibleConstructorReturn(this, (ArrayView.__proto__ || Object.getPrototypeOf(ArrayView)).call(this, element, 'array', [])), _this).booted) {

            _this.template = element.innerHTML.trim();_this.clear();
        }
        return _possibleConstructorReturn(_this);
    }

    _createClass(ArrayView, [{
        key: 'clear',
        value: function clear() {

            this.length = 0;

            this.content.innerHTML = '';

            return this;
        }
    }, {
        key: 'valueOf',
        value: function valueOf() {
            return Array.from(this, function (view) {
                return view.valueOf();
            });
        }

        /**
         * @param {Iterable} list
         *
         * @return {ArrayView}
         */

    }, {
        key: 'render',
        value: function render(list) {
            var _content,
                _ref,
                _this2 = this;

            var data = this.data;

            (_content = this.content).append.apply(_content, _toConsumableArray((_ref = []).concat.apply(_ref, _toConsumableArray(Array.from(list, function (item) {

                var view = _this2[_this2.length] = new _ObjectView2.default(_this2.template);

                data[data.length] = view.data;

                return view.render(item).content;
            })))));

            return this;
        }
    }, {
        key: 'push',
        value: function push() {
            for (var _len = arguments.length, item = Array(_len), _key = 0; _key < _len; _key++) {
                item[_key] = arguments[_key];
            }

            return this.render(item).length;
        }
    }]);

    return ArrayView;
}(_View3.default);

exports.default = ArrayView;