'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _View2 = require('./View');

var _View3 = _interopRequireDefault(_View2);

var _utility = require('./utility');

var _Template = require('./Template');

var _Template2 = _interopRequireDefault(_Template);

var _ArrayView = require('./ArrayView');

var _ArrayView2 = _interopRequireDefault(_ArrayView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var template_element = new WeakMap();

/**
 * View for Object model
 */

var ObjectView = function (_View) {
    _inherits(ObjectView, _View);

    /**
     * @param {string|Element|DocumentFragment} template
     */
    function ObjectView(template) {
        var _this;

        _classCallCheck(this, ObjectView);

        if (!(_this = _possibleConstructorReturn(this, (ObjectView.__proto__ || Object.getPrototypeOf(ObjectView)).call(this, template, 'object', {})), _this).booted) _this.scan();
        return _possibleConstructorReturn(_this);
    }

    _createClass(ObjectView, [{
        key: 'valueOf',
        value: function valueOf() {

            var data = Object.assign({}, this.data);

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = this[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var template = _step.value;

                    if (template instanceof _View3.default) data[template.name] = template.valueOf();
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return data;
        }

        /**
         * @private
         *
         * @param {Node|Attr} node
         * @param {function}  renderer
         *
         * @return {Template}
         */

    }, {
        key: 'register',


        /**
         * @private
         *
         * @param {Element|View} element
         * @param {Template}     [template]
         */
        value: function register(element, template) {

            if (element instanceof _View3.default) this[this.length] = element;else if (template[0]) template_element.set(this[this.length] = template, element);
        }

        /**
         * @private
         *
         * @param {Element} element
         */

    }, {
        key: 'parseTag',
        value: function parseTag(element) {
            var _this2 = this;

            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
                var _loop = function _loop() {
                    var attr = _step2.value;


                    var name = attr.name;

                    var template = ObjectView.templateOf(attr, name in element ? function (value) {
                        return element[name] = value;
                    } : function (value) {
                        return element.setAttribute(name, value);
                    });

                    if (template == '') element.removeAttribute(name);

                    _this2.register(element, template);
                };

                for (var _iterator2 = element.attributes[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    _loop();
                }
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }
        }

        /**
         * @private
         */

    }, {
        key: 'scan',
        value: function scan() {
            var _this3 = this;

            var root = this.content;

            root = root.parentNode ? root : {
                childNodes: root instanceof Array ? root : [root]
            };

            (0, _utility.mapTree)(root, 'childNodes', function (node) {

                switch (node.nodeType) {
                    case 1:
                        if (node.dataset.object) _this3.register(new ObjectView(node));else if (node.dataset.array) _this3.register(new _ArrayView2.default(node));else _this3.parseTag(node);
                        break;
                    case 3:
                        _this3.register(node, ObjectView.templateOf(node, function (value) {
                            return node.nodeValue = value;
                        }));
                }

                return node;
            });
        }

        /**
         * @param {Object} data
         *
         * @return {ObjectView}
         */

    }, {
        key: 'render',
        value: function render(data) {

            var _data_ = Object.assign(this.data, data);

            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
                for (var _iterator3 = this[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                    var template = _step3.value;


                    var _name = template.name;

                    if (template instanceof _Template2.default) template.evaluate(template_element.get(template), _data_);else if (template instanceof _View3.default && data[_name]) _data_[_name] = template.render(data[_name]).data;
                }
            } catch (err) {
                _didIteratorError3 = true;
                _iteratorError3 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                    }
                } finally {
                    if (_didIteratorError3) {
                        throw _iteratorError3;
                    }
                }
            }

            return this;
        }
    }, {
        key: 'clear',
        value: function clear() {
            var _iteratorNormalCompletion4 = true;
            var _didIteratorError4 = false;
            var _iteratorError4 = undefined;

            try {

                for (var _iterator4 = this[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                    var template = _step4.value;
                    template.clear();
                }
            } catch (err) {
                _didIteratorError4 = true;
                _iteratorError4 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion4 && _iterator4.return) {
                        _iterator4.return();
                    }
                } finally {
                    if (_didIteratorError4) {
                        throw _iteratorError4;
                    }
                }
            }

            return this;
        }
    }], [{
        key: 'templateOf',
        value: function templateOf(node, renderer) {

            return new _Template2.default(node.value || node.nodeValue, ['view'], renderer);
        }
    }]);

    return ObjectView;
}(_View3.default);

exports.default = ObjectView;